function lmn_out_ff=PID_reg(dt_ff,t_soustava,tw_ff,tH2O_ff,kr_ff,Tr_ff,Td_ff,feedf,lim,clamping_ff, deadzone_min,deadzone_max)

% funkce regulatoru
% vstupy: dt_ff - casovy krok vypoctu, t_soustava - casovy krok soustavy, 
% tw_ff - pozadovana teplota, tH20_ff - skutecna teplota, kr, Tr, Td - konstanty regulatoru,
% feedf - feedforward_input, lim - omezeni vstupu 0-100% (boolean), clamping_ff - clamping (0
% NE, 1 ANO), deadzone_min, deadzone_max - mrtva zona: min hodnota a max hodnota reg odchylky

persistent ef_ff
if(isempty(ef_ff))
  ef_ff=0;
end
persistent lmnI_ff
if(isempty(lmnI_ff))
  lmnI_ff=0;
end

persistent lmn_ff
if(isempty(lmn_ff))
  lmn_ff=0;
end

if t_soustava==0

if (isempty(deadzone_min))
  deadzone_act=0;
else
  deadzone_act=1;    
end

if deadzone_act==1 
  if (isempty(deadzone_max))
    deadzone_act=0;
  end
end
    
    
Td2_ff=Td_ff/3;  

if tw_ff==0
  ef_ff=0;  
  lmnI_ff=0;
  lmn_out_ff=0;
else
   
e_ff=tw_ff-tH2O_ff;
if deadzone_act==1
    if e_ff>deadzone_min && e_ff<deadzone_max
      e_ff=0;
    end
end
efold_ff=ef_ff;
ef_ff=ef_ff+1/Td2_ff*(e_ff-ef_ff)*dt_ff; %filtrovana reg. odchylka pro derivaci
lmnP_ff=e_ff*kr_ff;
lmnIcalc_step_back_ff=lmnI_ff;
lmnI_ff=lmnI_ff+kr_ff*e_ff/Tr_ff*dt_ff;
lmnD_ff=kr_ff*Td_ff*(ef_ff-efold_ff)/dt_ff;
lmn_ff=lmnP_ff+lmnI_ff+lmnD_ff;
lmn_ff=lmn_ff+feedf;

%clamping_ff
if clamping_ff==1
  if lmn_ff>100 || lmn_ff<0
    if lmn_ff*e_ff>0 && lmnIcalc_step_back_ff~=0
      lmnI_ff=lmnIcalc_step_back_ff;
    end
  end
end

if lim==1
  if lmn_ff>100
    lmn_ff=100; 
  end
  if lmn_ff<0 
    lmn_ff=0; 
  end
end
lmn_out_ff=100;

end
else
  if tw_ff~=0
    cas_sto_proc=lmn_ff/100*dt_ff;
    if t_soustava<=cas_sto_proc
      lmn_out_ff=100;
    else
      lmn_out_ff=0;   
    end
  else
    lmn_out_ff=0;    
  end
end