clear
back_calc=1;

p=10; %tlak
if p==2 load('MereniZavrena2Bar.mat'); end
if p==10 load('MereniZavrena10Bar.mat'); end


dt=0.1;
tKonec=tMereni(end);

iKonec=round(tKonec/dt);
out=zeros(iKonec,5);

%originalni PID
% kr=3;
% Tr=84;
% Td=22;

% %upravene PID
% kr=4;
% Tr=52;
% Td=22;

%PID z frekv. charakterisitiky
% kr=2;
% Tr=724;
% Td=24;

%upravene PID z frekv. charakterisitiky
kr=4;
Tr=384;
Td=28;

Td2=Td/3;
lmnMax=100;
lmnMin=0;

%pustit nadoba 2 pro nacteni parametru
tau=11.5;
Cnadoba=2900;%[J/K] tepelna kapacita nadoby vcetne vody v ni, stojanu...nadoba ma cca 0,25lt


%q_p=[0,0.3,1,2,3,4,5,6,7,10,20,35;0,0.02,0.03,0.04,0.05,0.055,0.06,0.067,0.08,0.09,0.12,0.16];% [bar],[lt/min] zavislost prutoku na tlaku
q_p=[0,2,10;0,0.01,0.108];% [bar],[lt/min] zavislost prutoku na tlaku
q_p(2,:)=q_p(2,:)/60; % [bar,kg/s]
q=interp1(q_p(1,:),q_p(2,:),p); %prutok z tabulky
cH2O=4180; %[J/kg/K] merna tepelna kapacita vody
pNspiraly=2000; %jmenovity vykon spiraly
tH2Oin=20; %teplota vstupni vody
alfa=340/60; %[W/K] salani nadoby do okoli (z namerenych prubehu s regulatorem v ustalenem stavu)

tOkoli=20;

pom=find(lmnMereni);
pom=pom(1);
twMereni=lmnMereni; %pozadovana teplota
twMereni(pom:end)=80;

%pocatecni podminky
x2=0;
x3=x2;
pSpiraly=x3;
tH2O=20;
lmnI=0;%37 protoze byla vypnuta spirala ale w=80, naintegrovano
ef=0;

for it=1:iKonec
    t=it*dt;
     
%     if p==10 && t>350 tH2Oin=8; end %snaha o hrb na krivce chladnuti, dotekla studena?
%     if p==2 && t>400 tH2Oin=8; end %snaha o hrb na krivce chladnuti, dotekla studena?
    
    tw=interp1(tMereni,twMereni,t);
    
    if tw==0
      ef(it)=0;
      lmn(it)=0;
      lmn_calc(it)=0;
      lmnI(it)=0;
      back_calc_sign(it)=0;
    else
    
    e(it)=tw-tH2O;
    efold(it)=ef(it-1);
    ef(it)=ef(it-1)+1/Td2*(e(it)-ef(it-1))*dt; %filtrovana reg. odchylka pro derivaci
    lmnP(it)=e(it)*kr;
%     if (lmn>lmnMin)&&(lmn<lmnMax) 
    if back_calc==1
      lmnI(it)=lmnI(it-1)+(kr*e(it)/Tr+back_calc_sign(it-1))*dt;
    else
      lmnI(it)=lmnI(it-1)+(kr*e(it)/Tr)*dt;
    end
%     end
    lmnD(it)=kr*Td*(ef(it)-efold(it))/dt;
    lmn(it)=lmnP(it)+lmnI(it)+lmnD(it);
    lmn_calc(it)=lmn(it);
    
    
    if lmn(it)>lmnMax lmn(it)=lmnMax; end
    if lmn(it)<lmnMin lmn(it)=lmnMin; end
    
    %back_calc
    if back_calc==1
      diff_act=lmn(it)-lmn_calc(it);
%      back_calc_koef=sqrt(Tr*Td);
      back_calc_koef=Tr;
      back_calc_sign(it)=(1/back_calc_koef)*diff_act;
    end
    

%     if tw<1 
%         lmnI=lmnI 
%     end
    
    x1=pNspiraly*lmn(it)/100;
    
    dpSpiraly=1/tau*(x3-pSpiraly);
    dx3=1/(tau/1)*(x2-x3);
    dx2=1/(tau/1)*(x1-x2);
    dtH2O=1/Cnadoba*(pSpiraly-q*cH2O*(tH2O-tH2Oin)-alfa*(tH2O-tOkoli));
        
    x2=x2+dx2*dt;
    x3=x3+dx3*dt;
    pSpiraly=pSpiraly+dpSpiraly*dt;
    tH2O=tH2O+dtH2O*dt;
    end
   
    out(it,:)=[t,lmn(end),pSpiraly/100,lmn(end),tH2O];
end


plot(tMereni,[twMereni,lmnMereni,tH20Mereni],out(:,1),out(:,4:5)) %simulovana teplota
set (gca,'fontsize',13)
xlabel('t [s]')
legend('t_{vody} pozadovana','lmn mereni','t_{vody} mereni','lmn simulace','t_{vody} simulace','location','east')
grid on
if p==2
  if back_calc==0
    saveas(gcf,'prechcharky2_n1_no_back.png');
  else
    saveas(gcf,'prechcharky2_n1_back.png');    
  end
end
if p==10
  if back_calc==0
    saveas(gcf,'prechcharky10_n1_no_back.png');
  else
    saveas(gcf,'prechcharky10_n1_back.png');    
  end
end

figure
plot(out(:,1),lmnI)
set (gca,'fontsize',13)
xlabel('t [s]')
grid on
title('Velikost integracni slozky')
ylabel('Hodnota integracni slozky [-]')
if back_calc==0
  saveas(gcf,'integr_slozka_no_back.png');
else
  saveas(gcf,'integr_slozka_back.png');    
end

figure
plot(out(:,1),lmn_calc)
set (gca,'fontsize',13)
xlabel('t [s]')
grid on
title('Velikost spocitaneho akcniho zasahu')
ylabel('Hodnota akcniho zasahu [%]')
if back_calc==0
  saveas(gcf,'akcni_zasah_no_back.png');
else
  saveas(gcf,'akcni_zasah_back.png');    
end

figure
plot(out(:,1),e)
set (gca,'fontsize',13)
xlabel('t [s]')
grid on
title('Velikost regulacni odchylky')
ylabel('Hodnota regulacni odchylky [\circC]')
if back_calc==0
  saveas(gcf,'reg_odchylka_no_back.png');
else
  saveas(gcf,'reg_odchylka_back.png');    
end

figure
plot(e,lmnI,'.')
set (gca,'fontsize',13)
xlabel('t [s]')
grid on
title('Zavislost regulacni odchylky na integratoru')
xlabel('Hodnota regulacni odchylky [\circC]')
ylabel('Hodnota integratoru [-]')
if back_calc==0
  saveas(gcf,'reg_odch_vs_integr_no_back.png');
else
  saveas(gcf,'reg_odch_vs_integr_back.png');    
end

figure
plot(lmnI,lmn_calc,'.')